﻿using System;
using System.Collections;
using System.Collections.Generic;
using Celeste;
using FMOD.Studio;
using Microsoft.Xna.Framework;
using Monocle;
using Celeste.Mod;

namespace CutsceneHelper
{
    [Tracked(true)]
    public class CustomPlayerDashAssist : PlayerDashAssist
    {
        static bool prevStateMachineLocked;
        static bool LockedMovement;
        public static void DashAssistInit(bool lockedMovement)
        {
            //bool dashAssist = SaveData.Instance.Assists.DashAssist;
            if (true)
            {

                LockedMovement = lockedMovement;
                Player player = Engine.Scene.Tracker.GetEntity<Player>();
                //player.StateMachine.ForceState(player.StartDash());
                prevStateMachineLocked = player.StateMachine.Locked;
                player.StateMachine.Locked = false;
                player.StateMachine.State = player.StartDash();
                //player.StateMachine.Locked = a;
                
                Input.LastAim = Vector2.UnitX * (float)player.Facing;
                Engine.DashAssistFreeze = true;
                Engine.DashAssistFreezePress = false;
                PlayerDashAssist playerDashAssist = Engine.Scene.Tracker.GetEntity<PlayerDashAssist>();
                bool flag = playerDashAssist == null;
                if (flag)
                {
                    player.Scene.Add(playerDashAssist = new CustomPlayerDashAssist());
                }
                playerDashAssist.Direction = Input.GetAimVector(player.Facing).Angle();
                playerDashAssist.Scale = 0f;
                playerDashAssist.Offset = ((player.CurrentBooster == null && player.StateMachine.PreviousState != 5) ? Vector2.Zero : new Vector2(0f, -4f));
                playerDashAssist.Visible = true;
                player.Add(new Coroutine(playerDashEndHook(), true));
                
            }
        }

        public static IEnumerator playerDashEndHook()
        {
            Player player = Engine.Scene.Tracker.GetEntity<Player>();
            while (Engine.DashAssistFreeze)
            {
                yield return null;
            }
            yield return 0.3f;
            if (SaveData.Instance.Assists.SuperDashing)
            {
                 yield return 0.15f;
            }
            if (prevStateMachineLocked)
            {
                player.StateMachine.State = Player.StDummy;
                player.StateMachine.Locked = true;
            }
            
            yield break;
        }


        public CustomPlayerDashAssist()
        {
            this.Scale = 0f;
            this.timer = 0f;
            this.paused = false;
            base.Tag = Tags.Global;
            base.Depth = -1000000;
            this.Visible = false;
            this.images = GFX.Game.GetAtlasSubtextures("util/dasharrow/dasharrow");
        }

        public override void Update()
        {
            if (!Engine.DashAssistFreeze)
            {
                if (paused)
                {
                    if (!Scene.Paused)
                    {
                        Audio.PauseGameplaySfx = false;
                    }
                    this.DisableSnapshot();
                    this.timer = 0f;
                    this.paused = false;
                }
            }
            else
            {
                this.paused = true;
                Audio.PauseGameplaySfx = true;
                this.timer += Engine.RawDeltaTime;
                bool flag4 = this.timer > 0.2f && this.snapshot == null;
                if (flag4)
                {
                    this.EnableSnapshot();
                }
                Player entity = base.Scene.Tracker.GetEntity<Player>();
                bool flag5 = entity == null;
                if (!flag5)
                {
                    float num = Input.GetAimVector(entity.Facing).Angle();
                    bool flag6 = Calc.AbsAngleDiff(num, this.Direction) >= 1.58079636f;
                    if (flag6)
                    {
                        this.Direction = num;
                        this.Scale = 0f;
                    }
                    else
                    {
                        this.Direction = Calc.AngleApproach(this.Direction, num, 18.849556f * Engine.RawDeltaTime);
                    }
                    this.Scale = Calc.Approach(this.Scale, 1f, Engine.DeltaTime * 4f);
                }
            }
        }

        public override void Render()
        {
            Player entity = base.Scene.Tracker.GetEntity<Player>();
            bool flag = entity == null;
            if (!flag)
            {
                bool flag2 = !Engine.DashAssistFreeze;
                if (!flag2)
                {
                    MTexture mtexture = null;
                    float num = float.MaxValue;
                    for (int i = 0; i < 8; i++)
                    {
                        float radiansA = 6.28318548f * ((float)i / 8f);
                        float num2 = Calc.AngleDiff(radiansA, this.Direction);
                        bool flag3 = Math.Abs(num2) < Math.Abs(num);
                        if (flag3)
                        {
                            num = num2;
                            mtexture = this.images[i];
                        }
                    }
                    bool flag4 = mtexture != null;
                    if (flag4)
                    {
                        bool flag5 = Math.Abs(num) < 0.05f;
                        if (flag5)
                        {
                            num = 0f;
                        }
                        mtexture.DrawOutlineCentered((entity.Center + this.Offset + Calc.AngleToVector(this.Direction, 20f)).Round(), Color.White, Ease.BounceOut(this.Scale), num);
                    }
                }
            }
        }

        private void EnableSnapshot()
        {
        }

        private void DisableSnapshot()
        {
            bool flag = this.snapshot != null;
            if (flag)
            {
                Audio.ReleaseSnapshot(this.snapshot);
                this.snapshot = null;
            }
        }

        public override void Removed(Scene scene)
        {
            this.DisableSnapshot();
            
            base.Removed(scene);
        }

        public override void SceneEnd(Scene scene)
        {
            this.DisableSnapshot();
            base.SceneEnd(scene);
        }

        public new float Direction;

        public new float Scale;

        public new Vector2 Offset;

        private List<MTexture> images;

        private EventInstance snapshot;

        private float timer;

        private bool paused;
    }
}
